import java.lang.Math;

//Statisk klasse som implementerer vanlige matematiske operasjoner som ikke er inkludert i java.lang.Math.
public final class M{

//Finner vinkelen mellom to kanter i 2D
public static double findAngle(Egde egde1, Egde egde2){
	//I praksis vil forhpentlig n2 og n3 vre den samme noden
	//Alts vil egde2 ofte vre lik egde1.next
	double[] n1 = egde1.getSource().getCoordinates();
	double[] n2 = egde1.getNext().getSource().getCoordinates();

	double[] n3 = egde2.getSource().getCoordinates();
	double[] n4 = egde2.getNext().getSource().getCoordinates();
	if (n2[0]!=n3[0] || n2[1]!=n3[1] || n2[2]!=n3[2]){
		System.out.println("Kantene stemmer ikke");
	}
	double[] e1 = M.makeVector(n2,n1);
	double[] e2 = M.makeVector(n3,n4);
	double angle = Math.acos(skalarprodukt(e1,e2)/(absVerdi(e1)*absVerdi(e2)));
	return angle;
}

//finner vinkelen <n1,n2,n3
public static double findAngle(Node node1, Node node2, Node node3){
	double[] n1 = node1.getCoordinates();
	double[] n2 = node2.getCoordinates();
	double[] n3 = node3.getCoordinates();
	double[] e1 = M.makeVector(n2,n1);
	double[] e2 = M.makeVector(n2,n3);
	double angle = Math.acos(skalarprodukt(e1,e2)/(absVerdi(e1)*absVerdi(e2)));
	return angle;
}

//lager en vektor mellom to punkter
public static double[] makeVector(double[] v1, double[] v2){
	double[] v = {v2[0] - v1[0], v2[1] - v1[1], v2[2] - v1[2]};
	return v;
}

//skalarproduktet av to vektorer
public static double skalarprodukt(double[] v1, double[] v2){
	if(v1.length!=v2.length){
		System.out.println("vektorene er ikke like lange");
		return 0;
	}
	if (v1.length==3){
		return v1[0]*v2[0] + v1[1]*v2[1] + v1[2]*v2[2];
	}
	else if(v1.length==2){
		return v1[0]*v2[0] + v1[1]*v2[1];
	}
	return 0;
}

//absoluttverdien (2-normen) til en vektor
public static double absVerdi(double[] v){
	//regner ut absoluttverdien til en 3-dimensjonal vektor
	if(v.length==3){
		return Math.sqrt(v[0]*v[0] + v[1]*v[1] +v[2]*v[2]);
	}
	else if (v.length==2){
		return Math.sqrt(v[0]*v[0] + v[1]*v[1]);
	}
	return 0;
}

//absoluttverdien til en skalar
public static double absVerdi(double v){
	if (v<0){
		return -v;
	}
	return v;
}

//kryssproduktet mellom to vektorer
public static double[] kryssprodukt(double[] v1, double[] v2){
	//3-d vektorer
	double[] kp = {v1[1]*v2[2] - v1[2]*v2[1], v1[2]*v2[0] - v1[0]*v2[2], v1[0]*v2[1] - v1[1]*v2[0]};
	return kp;
}


}